/***********************************************************************
 *
 * Copyright (C) 2003 Jan Fuchs
 *
 *              E-mail: fuky@seif.cz
 *                 Web: http://www.seif.cz
 *        Znakov sada: ISO-8859-2
 * Posledn modifikace: 23.11. 2003
 *
 *     Tento program je voln programov vybaven; mete jej it a
 * modifikovat podle ustanoven Obecn veejn licence GNU, vydvan
 * Free Software Foundation; a to bu verze 2 tto licence anebo
 * (podle vaeho uven) kterkoli pozdj verze.
 *
 *     Tento program je roziovn v nadji, e bude uiten, avak
 * BEZ JAKKOLI ZRUKY; neposkytuj se ani odvozen zruky PRODEJNOSTI
 * anebo VHODNOSTI PRO URIT EL.
 * Dal podrobnosti hledejte v Obecn veejn licenci GNU.
 *
 *    Kopii Obecn veejn licence GNU jste ml obdret spolu s tmto
 * programem; pokud se tak nestalo, napite o ni Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 ***********************************************************************/

#include <unistd.h>
#include <stdlib.h>
#include <curses.h>
#include <pthread.h>
#include <semaphore.h>
#include <assert.h>

#include "hra.h"
#include "objekty.h"

WINDOW *leve_window_ptr;
WINDOW *prave_window_ptr;
WINDOW *menu_window_ptr;

int HP_LINES;
int HP_COLS;
int prodleva;
char znak[2];

void *thread_result;

/* objekt[x][y][rotace][tvar] */
int objekt[4][4][5][OBJ_POCET];

void nova_hra(void);
void ulozit(void);
void konec(void);
void kon_vel_obr(void);

static void ini_hp(void);
static void nacist(void);
static void hp_kontrola(void);
static void leve_vymaz(void);
static void *posun(void *arg);
static void hraj(void);

static int sirka;
static int vyska;

static int rotace;
static int rotace_s;
static int tvar;   /* aktuln tvar    */
static int tvar_n; /* nsledujc tvar */
static int skore;
static int ukonci;
static int dohrano;

/* Souadnice objektu */
static int x;
static int x_s;
static int y;
static int y_s;
static int hp_x;
static int hp_y;
static int hp[101][51];

static int key;

static int res;
static pthread_t a_thread;
static pthread_mutex_t a_mutex;

static int i;
static int j;
static int rezim = 0;
static int stop;

/* Vypln cel lev okno mezerama */
static void leve_vymaz(void)
{
  for (i = 0; i < HP_PRAVA_X; ++i) {
    for (j = 0; j < HP_DOLNI_Y; ++j) {
      mvwprintw(leve_window_ptr, j + 1, i + 1, "%s", " ");
    }
  }

  wrefresh(leve_window_ptr);
} /*** leve_vymaz() ***/

/* Vlkno, kter zajiuje v pravidelnm intervalu posun objektu dol */
static void *posun(void *arg)
{
  while (ukonci == 0) {
    pthread_mutex_lock(&a_mutex);

    x_s = x;
    y_s = y;
    rotace_s = rotace;
    stop = 0;

    ++y;
    hraj();
    pthread_mutex_unlock(&a_mutex);
    usleep(prodleva);
  }
} /*** *posun() ***/

/* Zjst jestli jsou hotov nkter dky a ppadn je smae  */
/* a v ppad, e se objekty dostaly do maximln vky ukon */
/* hru */
static void hp_kontrola(void)
{
  int pocet;
  int x_k; /* kontroln souadnice  */
  int y_k;
  int x_p; /* pesouvac souadnice */
  int y_p;

  for (y_k = 0; y_k < HP_DOLNI_Y; ++y_k) {
    pocet = 0;
    for (x_k = 0; x_k < HP_PRAVA_X; ++x_k) {
      if (hp[x_k][y_k] == 1) {
	++pocet;
	if (y_k < 6) {
	  dohrano = 1;
	  ukonci = 1;
	}
      }
      else {
	if (y_k >= 6)
	  break;
      }
    }

    if (pocet == HP_PRAVA_X) {
      skore += HP_PRAVA_X;

      for (y_p = y_k; y_p >= 0; --y_p) {
	for (x_p = 0; x_p < HP_PRAVA_X; ++x_p) {
	  if (y_p == 0)
	    hp[x_p][y_p] = 0;
	  else
	    hp[x_p][y_p] = hp[x_p][y_p - 1];
	}
      }
    }
  } /* for */
} /*** hp_kontrola() ***/

static void hraj(void)
{
  /* Jestlie byli pouity klvesy pro pohyb objektu provede jejich */
  /* vyhodnocen                                                    */
  if ((x != x_s) || (y != y_s) || (rotace != rotace_s)) {
    /* Jestlie byla pouita klvesa pro rotaci */
    if (rotace != rotace_s) {
      sirka = objekt_sirka(rotace, tvar);
      assert(sirka);
      vyska = objekt_vyska(rotace, tvar);
      assert(vyska);
      /* Zjst zda je mon provst rotaci */
      if (x > (HP_PRAVA_X - sirka + 1))
	stop = 1;
      for (i = 0; i < 4; ++i) {
	if (stop == 1)
	  break;
	for (j = 0; j < 4; ++j) {
	  if (objekt[i][j][4][tvar] == 1) {
	    if (hp[x + i - 1][y - j - 1] == 1) {
	      stop = 1;
	      break;
	    }
	  }
	}
      } /* for */
    }
    /* Jinak byly pouity klvesy pro pohyb */
    else {
      /* Zjist zda je mon provst pohyb */
      for (i = 0; i < 4; ++i) {
	if (stop == 1)
	  break;
	for (j = 0; j < 4; ++j) {
	  if (objekt[i][j][rotace][tvar] == 1) {
	    if (hp[x + i - 1][y - j - 1] == 1) {
	      stop = 1;
	      break;
	    }
	  }
	}
      } /* for */
    }
    
    /* Jestlie je mon provst pohyb */
    if (stop == 0) {
      /* Smae pedchoz pozici */
      for (i = 0; i < 4; ++i) {
	for (j = 0; j < 4; ++j) {
	  if (objekt[i][j][rotace_s][tvar] == 1) {
	    hp_x = x_s + i - 1;
	    hp_y = y_s - j - 1;
	    assert((hp_x <= HP_PRAVA_X) && (hp_x >= 0));
	    assert((hp_y <= HP_DOLNI_Y) && (hp_y >= 0));
	    hp[hp_x][hp_y] = 0;
	  }
	}
      }

      /* Zape novou pozici */
      for (i = 0; i < 4; ++i) {
	for (j = 0; j < 4; ++j) {
	  if (objekt[i][j][rotace][tvar] == 1) {
	    hp_x = x + i - 1;
	    hp_y = y - j - 1;
	    assert((hp_x <= HP_PRAVA_X) && (hp_x >= 0));
	    assert((hp_y <= HP_DOLNI_Y) && (hp_y >= 0));
	    hp[hp_x][hp_y] = 2;
	  }
	}
      }
    }
    /* Jinak nen mon provst pohyb */
    else {
      /* Jestlie objekt dorazil na dno upevn ho a nastav */
      /* poten souadnice                               */
      if ((y_s != y) || (y >= HP_DOLNI_Y)) {
	for (i = 0; i < 4; ++i) {
	  for (j = 0; j < 4; ++j) {
	    if (objekt[i][j][rotace_s][tvar] == 1) {
	      hp_x = x_s + i - 1;
	      hp_y = y_s - j - 1;
	      assert((hp_x <= HP_PRAVA_X) && (hp_x >= 0));
	      assert((hp_y <= HP_DOLNI_Y) && (hp_y >= 0));
	      hp[hp_x][hp_y] = 1;
	    }
	  }
	}
	x = HP_STRED_X;
	y = 4;
	tvar = tvar_n;
	tvar_n = rand() % (OBJ_POCET - 1);
	sirka = objekt_sirka(rotace, tvar);
	assert(sirka);
	vyska = objekt_vyska(rotace, tvar);
	assert(vyska);
      }
      /* Jinak nastav star souadnice */
      else {
	x = x_s;
	rotace = rotace_s;
      }
    }
  } /* if */
  
  hp_kontrola();
  
  /* Aktualizuje hrac plochu */
  for (i = 0; i < HP_PRAVA_X; ++i) {
    for (j = 0; j < HP_DOLNI_Y; ++j) {
      if (hp[i][j] > 0) {
	if (hp[i][j] == 1)
	  wattrset(leve_window_ptr, COLOR_PAIR(1) | A_BOLD);
	else
	  wattrset(leve_window_ptr, COLOR_PAIR(4) | A_BOLD);
	
	if (rezim == 1)
	  mvwprintw(leve_window_ptr, j + 1, i + 1, "%d", hp[i][j]);
	else
	  mvwprintw(leve_window_ptr, j + 1, i + 1, "%s", znak);
      }
      else {
	mvwprintw(leve_window_ptr, j + 1, i + 1, "%s", " ");
      }
    }
  }

  for (i = 0; i < 4; ++i) {
    for (j = 0; j < 4; ++j) {
      if (objekt[i][j][rotace][tvar_n] == 1) {
	mvwprintw(prave_window_ptr, 6 - j, i + 9, "%s", znak);
      }
      else {
	mvwprintw(prave_window_ptr, 6 - j, i + 9, "%s", " ");
      }
    }
  }
  
  mvwprintw(prave_window_ptr, 9, 2, "Skre: %10d", skore);
  
  mvwprintw(prave_window_ptr, HP_LINES - 9, 2, "%s", "RIGHT  - doprava");
  mvwprintw(prave_window_ptr, HP_LINES - 8, 2, "%s", "LEFT   - doleva");
  mvwprintw(prave_window_ptr, HP_LINES - 7, 2, "%s", "DOWN   - dolu");
  mvwprintw(prave_window_ptr, HP_LINES - 6, 2, "%s", "UP     - rotace");
  mvwprintw(prave_window_ptr, HP_LINES - 4, 2, "%s", "F12    - vzhled");
  mvwprintw(prave_window_ptr, HP_LINES - 3, 2, "%s", "SPACE  - pauza");
  mvwprintw(prave_window_ptr, HP_LINES - 2, 2, "%s", "q      - konec");

  kon_vel_obr();
  wrefresh(prave_window_ptr);
  wrefresh(leve_window_ptr);
} /*** hraj() ***/

static void ini_hp(void)
{
  /* Poten nastaven hrac plochy */
  for (i = 0; i < HP_PRAVA_X; ++i) {
    for (j = 0; j < (HP_DOLNI_Y + 1); ++j) {
      /* Posledn dek se nastav na 1 */
      if (j == HP_DOLNI_Y)
	hp[i][j] = 1;
      /* Ostan dky se nastav na 0 */
      else
	hp[i][j] = 0;
    }
  }
} /*** ini_hp() ***/


static void nacist()
{
  FILE *fr;
  char c;
  char radek[31];
  char soubor[] = "save\0";
  int cis_rad = 1;

  if ((fr = fopen(soubor, "r")) == NULL)
    return;

  i = 0;
  while ((c = fgetc(fr)) != EOF) {
    if (c == '\n') {
      radek[i] = '\0';

      if ((cis_rad == 1) && (HP_PRAVA_X != atoi(radek)))
	return;
      else if ((cis_rad == 2) && (HP_DOLNI_Y != atoi(radek)))
	return;
      else if (cis_rad == 3)
	tvar = atoi(radek);
      else if (cis_rad == 4)
	rotace = atoi(radek);
      else if (cis_rad == 5)
	skore = atoi(radek);

      i = 0;
      ++cis_rad;
    }
    else {
      radek[i] = c;
      ++i;
    }
    if (cis_rad >= 6)
      break;
  }

  for (j = 0; j < HP_DOLNI_Y; ++j) {
    for (i = 0; i < HP_PRAVA_X; ++i) {
      if ((c = fgetc(fr)) != EOF) {
	if (c == '\n') {
	  if ((c = fgetc(fr)) == EOF)
	    break;
	}
	radek[0] = c;
	radek[1] = '\0';
	hp[i][j] = atoi(radek);
      }
    }
    if (c == EOF)
      break;
  }

  if (fclose(fr) == EOF) {
    konec();
    printf("Soubor %s se nepodailo uzavt.\n", soubor);
    exit(1);
  }
} /*** nacist() ***/

void nova_hra(void)
{
  objekt_vytvor();
  srand((unsigned) time(NULL));

  tvar = rand() % (OBJ_POCET - 1);
  tvar_n = rand() % (OBJ_POCET - 1);

  skore =0;
  rotace = 0;
  ukonci = 0;
  dohrano = 0;

  sirka = objekt_sirka(rotace, tvar);
  assert(sirka);
  vyska = objekt_vyska(rotace, tvar);
  assert(vyska);

  x = HP_STRED_X;
  y = 4;

  ini_hp();
  nacist();

  /* Smazn menu */
  touchwin(leve_window_ptr);
  wrefresh(leve_window_ptr);

  res = pthread_mutex_init(&a_mutex, NULL);
  if (res != 0) {
    konec();
    fprintf(stderr, "CHYBA: Pi inicializaci mutexu nastala chyba.\n");
    exit(1);
  }

  res = pthread_create(&a_thread, NULL, posun, NULL);
  if (res != 0) {
    konec();
    fprintf(stderr, "CHYBA: Pi vytvoen vlkna nastala chyba.\n");
    exit(1);
  }

  key = wgetch(leve_window_ptr);

  /* Pi chyb, stisku q nebo ESC vrt do hlavnho menu  */
  while (key != ERR && key != 'q' && key != LOCAL_ESCAPE_KEY) {
    x_s = x;
    y_s = y;
    rotace_s = rotace;
    stop = 0;

    switch (key) {
    case KEY_LEFT:
      if (x > 1)
	--x;
      break;
    case KEY_RIGHT:
      if (x <= (HP_PRAVA_X - sirka))
	++x;
      break;
    case KEY_DOWN:
      ++y;
      break;
    case KEY_UP:
      if (rotace > 2)
	rotace = 0;
      else
	++rotace;
      break;
    case KEY_F(12):
      if (rezim == 0)
	rezim = 1;
      else
	rezim = 0;
      break;
    case LOCAL_SPACE_KEY:
      ukonci = 1;

      wattrset(prave_window_ptr, COLOR_PAIR(3) | A_BOLD);
      mvwprintw(prave_window_ptr, 11, 2, "%s", "Pauza");
      wrefresh(prave_window_ptr);

      key = wgetch(leve_window_ptr);
      while ((key != ERR) && (key != LOCAL_SPACE_KEY)) {
	key = wgetch(leve_window_ptr);
      }

      mvwprintw(prave_window_ptr, 11, 2, "%s", "     ");
      wattrset(prave_window_ptr, COLOR_PAIR(1) | A_BOLD);
      wrefresh(prave_window_ptr);

      ukonci = 0;
      res = pthread_create(&a_thread, NULL, posun, NULL);
      break;
    case LOCAL_ENTER_KEY:
      break;
    default:
      break;
    } /* switch */

    pthread_mutex_lock(&a_mutex);
    hraj();
    pthread_mutex_unlock(&a_mutex);

    if (dohrano == 1)
      break;

    key = wgetch(leve_window_ptr);
  } /* while */

  ukonci = 1;
  leve_vymaz();
} /*** nova_hra() ***/

void ulozit()
{
  FILE *fw;
  char soubor[] = "save\0";

  if ((fw = fopen(soubor, "w")) == NULL) {
    konec();
    printf("Soubor %s se nepodailo otevt.\n", soubor);
    exit(1);
  }

  if (fprintf(fw, "%d\n%d\n%d\n%d\n%d\n",
	      HP_PRAVA_X, HP_DOLNI_Y, tvar, rotace, skore) == EOF) {
    konec();
    printf("Hru se nepodailo uloit.\n");
    exit(1);
  }

  for (j = 0; j < HP_DOLNI_Y; ++j) {
    for (i = 0; i < HP_PRAVA_X; ++i) {
      if (hp[i][j] == 2)
	hp[i][j] = 0;
      if (fprintf(fw, "%d", hp[i][j]) == EOF) {
	konec();
	printf("Hru se nepodailo uloit.\n");
	exit(1);
      }
    }
    fputc('\n', fw);
  }

  if (fclose(fw) == EOF) {
    konec();
    printf("Soubor %s se nepodailo uzavt.\n", soubor);
    exit(1);
  }
} /*** ulozit() ***/

/* Zjist zda nedolo k zmn potu dk a sloupc na obrazovce. */
void kon_vel_obr(void)
{
  if ((HP_LINES != LINES) || (HP_COLS != COLS)) {
    konec();
    fprintf(stderr, "CHYBA: Nesmte mnit COLS a LINES.\n");
    exit(1);
  }

  if ((COLS >= 100) || (COLS < 45) || (LINES >= 50) || (LINES < 22)) {
    konec();
    fprintf(stderr, "CHYBA: Zkzan velikost obrazovky.\n");
    exit(1);
  }
} /*** kon_vel_obr() ***/

/* Uklz ped ukonen programu */
void konec(void)
{
  pthread_mutex_destroy(&a_mutex);

  delwin(leve_window_ptr);
  delwin(prave_window_ptr);
  delwin(menu_window_ptr);

  clear();
  refresh();

  endwin();
} /*** konec() ***/
